var request = require("request"),
  stringify = require("querystring").stringify
  url = 'https://bittrex.com/api/v1/public/';

function Bittrex(apiKey) {
  this.apiKey = apiKey;
}

Bittrex._apiQuery = function(method, args, callback) {
  var options = {
    uri: url + method + "?" + stringify(args),
    agent: false,
    method: 'GET',
    headers: {
      "User-Agent": "Mozilla/4.0 (compatible; CoinedUp API node client)",
      "Content-type": "application/x-www-form-urlencoded"
    },
    "rejectUnauthorized": false
  };

  request(options, function(err, res, body) {
    try {
      var response = JSON.parse(body);
      if(typeof callback == typeof Function)
        if(response.success == true)
          callback(false, response.result);
        else
          callback(response.message, false);
    } catch(e) {
      console.log(e);
    }
  });
}

Bittrex.markets = function(callback) {
  Bittrex._apiQuery('getmarkets', callback);
}

Bittrex.currencies = function(callback) {
  Bittrex._apiQuery('getcurrencies', callback);
}

Bittrex.ticker = function(market, callback) {
  Bittrex._apiQuery('getticker', { market: market }, callback);
}

Bittrex.marketSummaries = function(callback) {
  Bittrex._apiQuery('getmarketsummaries', callback);
}

Bittrex.orderbook = function(market, callback, type, depth) {
  if(!type) type = "both";
  if(!depth) depth = 100;
  Bittrex._apiQuery('getorderbook', { market: market, type: type, depth: depth }, callback);
}

Bittrex.trades = function(market, callback, count) {
  if(!count) count = 100;
  Bittrex._apiQuery('getmarkethistory', { market: market, count: count }, callback);
}

module.exports = Bittrex;